// file: ~/server/api/auth/[...].ts
import CredentialsProvider from 'next-auth/providers/credentials'
import { NuxtAuthHandler } from '#auth'
import bcrypt from 'bcrypt'

export default NuxtAuthHandler({
  // A secret string you define, to ensure correct encryption
  secret: useRuntimeConfig().AUTH_SECRET,
  pages: {
    signIn: '/login',
    error: '/login',
    signOut: '/logout',

  },
  providers: [
    // @ts-expect-error You need to use .default here for it to work during SSR. May be fixed via Vite at some point
    CredentialsProvider.default({

      name: 'Credentials',

      credentials: {

      },
      async authorize(credentials: { email: string, password: string }) {

        const user = await User.findOne({ email: credentials.email })


        if (!user) {
          throw createError({
            statusCode: 401,
            message: 'Mauvais identifiants '

          })
        }
        const isvalid = await bcrypt.compare(
          credentials.password,
          user.password

        )
        if (!isvalid) {
          throw createError({
            statusCode: 401,
            message: 'Mauvais identifiants '

          })

        }


        return {
          ...user.toObject(),
          password: undefined
        }

      }
    })
  ],
  session: {
    strategy: 'jwt',
  },
  callbacks: {
    async jwt({ token, account, user }) {
      if (user) {
        token = { ...token, ...user }
      }
      return token
    },
    async session({ session, token }) {
      session.user = {
        ...session.user,
        ...token
      }
      return session
    }
  }


})
