import {User} from '~/server/models/User'
import bcrypt from 'bcrypt'

export default defineEventHandler( async(event)=>{
    const body = await readBody(event)
    if (!body.email || !body.password || !body.name || !body.lastname || !body.username) {
        throw createError({
            statusCode: 400,
            statusMessage: 'Mauvaise requête',
            message: 'Tous les champs sont requis'
        })
        
    
        
    }
    const sel = await bcrypt.genSalt(10);
    const hashedPass = await bcrypt.hash(body.password, sel);

    const user = await User.create({...body, password: hashedPass})
    return {...user, password: undefined}
})
