import {Schema,model} from 'mongoose' 

export interface UserDocument extends Document{
    email:string,
    password:string,
    name:string,
    lastname:string,
    username:string
}
const UserSchema = new Schema({
    email:{
        type:String,
        required:true,
        unique:true,
        lowercase:true,
        trim:true
    },
    password:{
        type:String,
        required:true,
        trim:true,
        length:[8,"Le mot de passe doit contenir au moins 8 caractères"]
    },
    name:{
        type:String,
        required:true,
        trim:true,
        
    },
    lastname:{
        type:String,
        required:true,
        trim:true
    },
    username:{
        type:String,
        required:true,
        unique:true,
        trim:true
    },
    createdAt:{
        type:Date,
        default:Date.now
    },
    admin :{
        type:Boolean,
        default:false
    
    }
    
})

export const User = model<UserDocument>('User',UserSchema)